import 'package:example/state.dart';
import 'package:example/state.sealed.dart';

main() {
  State state = States.dataState("Nice");
  final switchImpl = StateSwitchImpl(
    state: (s) => s.toString(),
  );
  print(switchImpl.switchCase(state));
  final result = SampleBloc().add(state);
  assert(result);
}

class SampleBloc with StateSwitch<bool> {
  add(State state) {
    switchCase(state);
  }

  @override
  bool onDataState(DataState dataState) {
    print(dataState.message);
    return true;
  }

  @override
  bool onInitState(InitState initState) {
    return false;
  }

  @override
  bool onNamedState(NamedState namedState) {
    return false;
  }

  @override
  bool onOnlyNamedState(OnlyNamedState onlyNamedState) {
    return false;
  }

  @override
  bool onProgressState(ProgressState progressState) {
    return false;
  }
}
